%include "main.inc"


[GLOBAL DEFORM_Init]
[GLOBAL DEFORM_DoFrame]
[GLOBAL tptr]

[SEGMENT .bss USE32]

tptr    RESB    1

; iqiqiq
EXTERN VBuffADDR
EXTERN VBuffADDR2


[SEGMENT .data USE32]

R128        dd  128.0       ; ray
R255        dd  255.0       ; deform

RINV        dd  0.005       ; 1.0 / sqrt( 160^2 + 120^2 )

;%if XRES=320
;%endif
%if XRES=800
RSCA        dd  0.4         ; 320/800
%endif
%if XRES=1920
RSCA        dd  0.16667         ; 320/1920
%endif

;ticks       dd 0

[SEGMENT .text USE32]

;
; edi = destino
; esi = textura
; ebx = tabla
; eax = time
;




; please keep in synch with those in intro.asm
%define VBUFSIZE  (4*(XRES*YRES + 2*XRES + 128))
%define VBUF2SIZE (4*(XRES*YRES + 1*XRES + 128))
%define TABLASIZE (2*(XRES*YRES + 128))

%define O_VBUF2 (VBUFSIZE)
%define O_TABLA (VBUFSIZE+VBUF2SIZE)
%define O_TEXT  (VBUFSIZE+VBUF2SIZE+TABLASIZE)


;deformacion recursiva
;
;
;
DEFORM_DoFrame:
    
    pushad
    mov     bl, [tptr]
    or      bl, bl
    jnz     doframe
    popad
    ret

doframe:

    shr eax, 4
    mov ah, al
    add ah, ah
    mov edi, eax        ; edi = movimiento

    mov ebp, 0000ffffh

    mov ecx, -XRES*YRES
    mov esi, VBuffADDR      ; esi = destino.....
    add esi, XRES*YRES*4

next:
      ; coge de la tabla
      mov ax, [esi-XRES*YRES*4+O_TABLA+ecx*2+XRES*YRES*2]
      xor ebx, ebx
      add eax, edi

      ; pinta en pantalla
      mov [esi-XRES*YRES*4+O_VBUF2+ecx*4-4+XRES*YRES*4], edx


      cmp al, 225
      ja  norec
      cmp ah, 225
      ja  norec

;jmp norec
      ; lee del buffer y oscurece...
sirec:

%if XRES==320
      mov bl,  ah       ; 
      and eax, ebp      ; ah*256+al &= 0xffff
      shl ebx, 6        ; ebx = ah*64
      add ebx, eax      ; ebx = ah*320 + al
%else

;      mov bl, ah
;      imul ebx, ebx, YRES
;      shr  ebx, 8
 
;      and eax, 255
;      imul eax, eax, XRES
;      shr eax, 8

;      imul ebx, ebx, XRES
;      add ebx, eax
%endif      

      and eax, ebp      ; ah*256+al &= 0xffff

      ; lee el pixel de la textura
      mov edx, [esi+ebx*4-XRES*YRES*4]

      shr edx, 1  ; oscurece el color...
      and edx, 07f7f7f7fh

      inc ecx
      jnz next

      jmp suavito

norec:
      ; lee de la textura
      and eax, ebp

      inc ecx
      ; lee el pixel de la textura
      mov edx, [esi-XRES*YRES*4 + O_TEXT + eax*4]
      jnz next

      ;─ ─ Suavizado ─ ─

suavito:

      mov ebp, 0fcfcfcfch
      mov ecx, -XRES*YRES
    lpdifum:
      mov eax, [esi+O_VBUF2+ecx*4+XRES*4]
      mov ebx, [esi+O_VBUF2+ecx*4]
      and eax, ebp
      mov edx, [esi+O_VBUF2+ecx*4+4]
      and ebx, ebp
      mov edi, [esi+O_VBUF2+ecx*4+XRES*4+4]
      and edx, ebp
      and edi, ebp
      add eax, ebx
      add eax, edi
      add eax, edx
      shr eax, 2
      mov [esi+ecx*4], eax
      inc ecx
      jnz lpdifum

      popad
      ret

;-----------------------------------------------------------------------------
; DEFORM_Init
;
; edi = tabla ( XRES*YRES )
; ebx = cual
;-----------------------------------------------------------------------------
%define VAR0 (ebp+0)
%define VAR1 (ebp+4)
%define VAR2 (ebp+8)
DEFORM_Init:
    pushad


    ; variables locales en stack 
    pushad
    mov     ebp, esp


    
    mov ecx, YRES
    @loopY2B:
        mov edx, XRES
        @loopX2B:

            mov     eax, (XRES/2)
            sub     eax, edx
            mov     [VAR0], eax

            mov     eax, (YRES/2)
            sub     eax, ecx
            mov     [VAR1], eax


            fild    dword [VAR0]       ; i-xres/2
            %if XRES>320
            fmul    dword [RSCA]
            %endif
            fild    dword [VAR1]       ; i-xres/2 j-yres/2
            %if XRES>320
            fmul    dword [RSCA]
            %endif


            call    mitabla

            mov     eax, [VAR0]

            stosw

        dec edx
        jnz @loopX2B
    loop @loopY2B

    ; fuera vars. locales
    popad

    popad
    ret




;
; ebx = cual
;
mitabla:
    pushad


    fld     st1                   ; x y x
    fld     st1                   ; x y x y
    fpatan                          ; x y a
    fxch    st2                   ; a y x

    fmul    st0, st0            ; a y x²
    fxch    st1                   ; a x² y
    fmul    st0, st0            ; a x² y²
    faddp   st1                     ; a x²+y²
    fsqrt                           ; a r         r = [0,189]
    fmul    dword [RINV]      ; a r         r = [0,1]




    ;---------------------------------------
    ; hay que dejar en la pila : r a
    ;---------------------------------------

%if 1
    shr     ebx, 1
    jc      tu1
    shr     ebx, 1
    jc      tu2
    shr     ebx, 1
    jc      tu3
    jmp     tu4


        tu1:
            fld1                            ; a   r 1
            fsubp   st1                   ; a   1-r
            fxch                            ; 1-r a
            jmp     notab
        ;--------------
        tu2:
            fadd    st0, st0
            fxch
            fadd    st0, st0
            jmp     notab

        ;--------------

        tu3:
            fmul    st0, st0            ; a  r²
            fxch                            ; r² a
            jmp     notab

        ;--------------
        tu4:
            fxch
            fld     st1                   ; r a r
            fadd    st0, st0            ; r a 2r
            fcos                            ; r a cos(2r)
            faddp    st1                    ; r a+cos(2r)
            ;jmp     notab
%else

    tu1:
    shr     ebx, 1
    jnc     tu2

            fld1                            ; a   r 1
            fsubp   st1                   ; a   1-r
            fxch                            ; 1-r a

    tu2:
    shr     ebx, 1
    jnc     tu3

            fadd    st0, st0
            fxch
            fadd    st0, st0

    tu3:
    shr     ebx, 1
    jnc     tu4

            fmul    st0, st0            ; a  r²
            fxch                            ; r² a
    tu4:
    shr     ebx, 1
    jnc     notab

            fxch
            fld     st1                   ; r a r
            fadd    st0, st0            ; r a 2r
            fcos                            ; r a cos(2r)
            faddp                           ; r a+cos(2r)


%endif

    notab:
    ;---------------------------------------
    ; suponemos en la pila r y a
    ;---------------------------------------

                                        ; r a
    fsincos                             ; r sin cos
    fmul        st0, st2            ; r sin r·cos
    fmul        dword [R255]      ; r sin u
    fistp       dword [VAR0]        ; r sin 
    fmulp       st1, st0            ; r·sin
    fmul        dword [R255]      ; v
    fistp       dword [VAR0+1]      ;


    popad
    ret
