//#pragma warning(disable: 4078)

#include "main.h"

#define WIN32_LEAN_AND_MEAN
#define WIN32_EXTRA_LEAN
#include <windows.h>
#include "intro.h"

//----------------------------------------------------------------------------

static int dwStyle = WS_VISIBLE|WS_POPUP|WS_CLIPSIBLINGS|WS_CLIPCHILDREN;

static BITMAPINFO   bmi = { { sizeof(BITMAPINFOHEADER),
                            XRES, -YRES, 1, 32, BI_RGB,
                            0, 0, 0, 0, 0 }, { 0, 0, 0, 0 } };

#ifdef __cplusplus
extern "C" { int _fltused = 0; }
#else
int _fltused = 0;
#endif

static HDC  hDC;
static long buffer[XRES*YRES] = {0};

//----------------------------------------------------------------------------

static void pinta( void )
{
    StretchDIBits(hDC,0,0,XRES,YRES,0,0,XRES,YRES,buffer,&bmi,DIB_RGB_COLORS,SRCCOPY);
}

extern "C" void entrypoint( void )
{
    MSG     msg;
    HWND    hWnd;
    DWORD   dwExStyle;
    DEVMODE dmScreenSettings;
    int     fullscreen;
    long    to = 0;
    RECT    rec = {0,0,XRES,YRES};
    int     done;


    fullscreen = (MessageBox( 0, "fullscreen?", TITULO, MB_YESNO|MB_ICONQUESTION)==IDYES );

    //--------------------------------------------------------

    if( fullscreen )
		{
        //memset(&dmScreenSettings,0,sizeof(DEVMODE));
        //for( int i=0; i<sizeof(DEVMODE); i++ ) { ((unsigned char*)&dmScreenSettings)[i] = 0; }

        dmScreenSettings.dmSize       = sizeof(DEVMODE);
        dmScreenSettings.dmFields     = DM_BITSPERPEL|DM_PELSWIDTH|DM_PELSHEIGHT;
        dmScreenSettings.dmBitsPerPel = 32;
        dmScreenSettings.dmPelsWidth  = XRES;
        dmScreenSettings.dmPelsHeight = YRES;

        if( ChangeDisplaySettings(&dmScreenSettings,CDS_FULLSCREEN)!=DISP_CHANGE_SUCCESSFUL)
            return;

        while( ShowCursor( 0 )>=0 );
        }
    else
		{
        dwStyle |= WS_CAPTION;
		}

    //--------------------------------------------------------

    AdjustWindowRect( &rec, dwStyle, 0 );

    hWnd = CreateWindowEx( WS_EX_TOPMOST, "STATIC", TITULO, dwStyle,
                           (GetSystemMetrics(SM_CXSCREEN)-rec.right+rec.left)>>1,
                           (GetSystemMetrics(SM_CYSCREEN)-rec.bottom+rec.top)>>1,
                           rec.right-rec.left, rec.bottom-rec.top,
                           0, 0,
                           GetModuleHandle(0),
                           0 );

    if( !hWnd ) return;

    SetForegroundWindow( hWnd );
    SetFocus( hWnd );

    //--------------------------------------------------------

    hDC = GetDC( hWnd );

    if( !hDC ) return;

    //--------------------------------------------------------

    pinta();

    intro_init();

    do
    {
        PeekMessage(&msg,0,0,0,PM_REMOVE);

        if( !to ) to=msg.time;

        done = intro_do( buffer, msg.time-to );

        pinta();

    }while( (msg.message!=WM_KEYDOWN) && !done );

    //--------------------------------------------------------

    ReleaseDC( hWnd, hDC );
    DestroyWindow( hWnd );

    if( fullscreen )
		{
        ChangeDisplaySettings( 0, 0 );
        while( ShowCursor( 1 )<0 );
		}
}
