%include "main.inc"

; [ ] Random
; [x] Lissa
; [x] RGB_Scale
; [x] RGB_Blend

[GLOBAL Random]
[GLOBAL Lissa]
[GLOBAL RGB_Scale]
[GLOBAL mirand]

[SEGMENT .bss USE32]
mirand RESD 1

[SEGMENT .text USE32]

%if 0
;----------------------------------------------------------------------------;
; Random
;
; in			:
; out 		: eax
; machaca :
;----------------------------------------------------------------------------;
Random:
    mov             eax, [mirand]
    imul            eax, 015a4e35h
    inc             eax
    mov             [mirand], eax
    shr             eax, 16
    ret
%endif

;----------------------------------------------------------------------------;
; Lissa
;
; in      : edi, esi
; out     :
; machaca : ecx
;
;----------------------------------------------------------------------------;
%if 1
; edi : vector
; esi : struct
; eax : t
Lissa:
    mov     [esp-256], eax
    fild    dword [esp-256]

    fld     st0
    fld     st0               ; t t t
    xor     ecx, ecx
    mov     cl, 3
    @lilo:
        fmul    dword [esi+0]
        fadd    dword [esi+4]
        fsin
        fmul    dword [esi+8]
        fstp    dword [edi]
        add     esi, byte 12
        add     edi, byte 4
    loop @lilo
    ret
%endif

;----------------------------------------------------------------------------;
; RGB_Scale
;
; eax = (eax*cl)>>8
;
; in      : eax, ecx
; out     : eax
; machaca : ebx, edx
;----------------------------------------------------------------------------;
RGB_Scale:
    mov             edx, eax
    mov             ah, 0           ;and             eax, 00ff00ffh
    and             edx, 0000ff00h
    imul            eax, ecx
    imul            edx, ecx
    shr             eax, 8
    shr             edx, 8
    mov             ah, dh
    ret

