%include "main.inc"

; [x] MATH_Modulo PROC
; [x] MATH_Normalize PROC
; [ ] MATH_VecCross PROC
; [x] MATH_VecDot PROC
; [x] MATH_VecSub PROC
; [ ] MATH_VecAdd PROC
; [x] MATH_VecAdd2 PROC
; [x] MATH_VecScale PROC
; [x] MATH_VecCopy PROC


[GLOBAL MATH_Modulo]
[GLOBAL MATH_Normalize]
;[GLOBAL MATH_VecCross]
[GLOBAL MATH_VecDot]
[GLOBAL MATH_VecSub]
;[GLOBAL MATH_VecAdd]
[GLOBAL MATH_VecAdd2]
[GLOBAL MATH_VecScale]
[GLOBAL MATH_VecCopy]


[SEGMENT .text USE32]


%if 0
;-----------------------------------------------------------------------------
; MATH_VecCross
;
; edi = esi·ebx
;-----------------------------------------------------------------------------
MATH_VecCross:
    fld     dword [esi+4]       ; uy
    fmul    dword [ebx+8]       ; uy·vz
    fld     dword [esi+8]       ; uy·vz uz
    fmul    dword [ebx+4]       ; uy·vz uz·uy
    fld     dword [esi+8]       ; uy·vz uz·uy  uz
    fmul    dword [ebx+0]       ; uy·vz uz·uy  uz·vx
    fld     dword [esi+0]       ; uy·vz uz·uy  uz·vx ux
    fmul    dword [ebx+8]       ; uy·vz uz·uy  uz·vx ux·vz
    fld     dword [esi+0]       ; uy·vz uz·uy  uz·vx ux·vz  ux
    fmul    dword [ebx+4]       ; uy·vz uz·uy  uz·vx ux·vz  ux·vy
    fld     dword [esi+4]       ; uy·vz uz·uy  uz·vx ux·vz  ux·vy uy
    fmul    dword [ebx+0]       ; uy·vz uz·uy  uz·vx ux·vz  ux·vy uy·vx
    fsubp                       ; uy·vz uz·uy  uz·vx ux·vz  ux·vy-uy·vx
    fstp    dword [edi+8]       ; uy·vz uz·uy  uz·vx ux·vz 
    fsubp                       ; uy·vz uz·uy  uz·vx-ux·vz 
    fstp    dword [edi+4]       ; uy·vz uz·uy 
    fsubp                       ; uy·vz-uz·uy 
    fstp    dword [edi+0]       ;
    ret
%endif

;-----------------------------------------------------------------------------
; MATH_VecDot
;
; st(0) = edi·esi
;-----------------------------------------------------------------------------
MATH_VecDot:
    fld     dword [esi+0]       ; v1->x
    fmul    dword [edi+0]       ; v1->x*v2->x
    fld     dword [esi+4]       ; v1->x*v2->x v1->y
    fmul    dword [edi+4]       ; v1->x*v2->x v1->y*v2->y
    faddp   st1                     ; v1->x*v2->x+v1->y*v2->y
    fld     dword [esi+8]       ; v1->x*v2->x+v1->y*v2->y v1->z
    fmul    dword [edi+8]       ; v1->x*v2->x+v1->y*v2->y v1->z*v2->z
    faddp   st1                     ; v1->x*v2->x+v1->y*v2->y+v1->z*v2->z
    ret

;-----------------------------------------------------------------------------
; MATH_VecSub
;
; edi = esi-ebp
;-----------------------------------------------------------------------------
MATH_VecSub:
    fld     dword [esi+0]
    fsub    dword [ebp+0]
    fstp    dword [edi+0]
    fld     dword [esi+4]
    fsub    dword [ebp+4]
    fstp    dword [edi+4]
    fld     dword [esi+8]
    fsub    dword [ebp+8]
    fstp    dword [edi+8]
    ret


%if 0
;-----------------------------------------------------------------------------
; MATH_VecAdd
;           
; [edi] = [esi]+[ebx]
;-----------------------------------------------------------------------------
MATH_VecAdd:
    fld     dword [esi+0]   ; x1
    fadd    dword [ebx+0]   ; x1+x2
    fstp    dword [edi+0]   ; 
    fld     dword [esi+4]   ; y1
    fadd    dword [ebx+4]
    fstp    dword [edi+4]
    fld     dword [esi+8]
    fadd    dword [ebx+8]
    fstp    dword [edi+8]
    ret
%endif

;-----------------------------------------------------------------------------
; MATH_VecAdd2
;           
; edi += esi
;-----------------------------------------------------------------------------
MATH_VecAdd2:
    fld     dword [edi+0]
    fadd    dword [esi+0]
    fstp    dword [edi+0]
    fld     dword [edi+4]
    fadd    dword [esi+4]
    fstp    dword [edi+4]
    fld     dword [edi+8]
    fadd    dword [esi+8]
    fstp    dword [edi+8]
    ret

; edi *= st(0)
MATH_VecScale:
    fld     st0                 ; t t
    fld     st0                 ; t t t
    fmul    dword [edi+0]       ;
    fstp    dword [edi+0]       ;
    fmul    dword [edi+4]       ;
    fstp    dword [edi+4]       ;
    fmul    dword [edi+8]       ;
    fstp    dword [edi+8]       ;
    ret


; [edi] = [esi]
MATH_VecCopy:
    pushad
    movsd
    movsd
    movsd
    popad
    ret

;-----------------------------------------------------------------------------
; MATH_Modulo
;
; st0 = |edi|
;-----------------------------------------------------------------------------
MATH_Modulo:
    %if FAST==1
        fld     dword [edi+0]       ; x
        fmul    dword [edi+0]       ; x²
        fld     dword [edi+4]       ; x² y
        fmul    dword [edi+4]       ; x² y²
        fld     dword [edi+8]       ; x² y² z
        fmul    dword [edi+8]       ; x² y² z²
        faddp   st1                     ; x²+y²+z²
        faddp   st1                     ; x²+y²+z²
    %else
        push    esi
        mov     esi, edi
        call    MATH_VecDot
        pop     esi
    %endif
    fsqrt                               ; mod
    ret


; edi 
MATH_Normalize:
    call    MATH_Modulo             ; m
    fld1                            ; m 1
    fdivrp  st1                     ; im
    call    MATH_VecScale           ;
    ret
