%include "main.inc"
%include "mmath.inc"
%include "ray_ker.inc"

[GLOBAL RAY_CalcCamera]

[GLOBAL incx]
[GLOBAL incy]
[GLOBAL vecy]

[SEGMENT .data USE32]

;   ?     ?     ?       ;  [ 0]   [ 4]   [ 8]
;   ?     ?     ?       ;  [12]   [16]   [20]
;   x     y     z       ;  [24]   [28]   [32]

;   z     0     -x
; -xy   x²+z²  -yz
;   x     y      z

;   z     0    -x
; -xy   1-y²  -yz
;   x     y     z


%if XRES==320
    ddx     dd   0.00626959      ; 2.0*INC*/(float)(XRES-1);
    ddy     dd  -0.00627615     ; 2.0*INC*/(float)(YRES-1) * .75;
%endif
%if XRES==800
    ddx     dd   0.0025031289      ; 2.0*INC*/(float)(XRES-1);
    ddy     dd  -0.002504174     ; 2.0*INC*/(float)(YRES-1) * .75;
%endif
%if XRES==1920
    ddx     dd   0.0010424      ; 2.0*INC*/(float)(XRES-1);
    ddy     dd  -0.0010424      ; 2.0*INC*/(float)(YRES-1) * 6/19;
%endif


[SEGMENT .bss USE32]
;cammatrix   RESD 9
vecy:
esc0        RESD 3

cammatrix:
incx:       RESD 3
incy        RESD 3
            RESD 3


[SEGMENT .text USE32]

RAY_CalcCamera:
    pushad

    ; sacamos los 3 ejes, uséase, construimos la matriz de cámara

    mov     ebp, campos
    mov     esi, camtarget
    mov     edi, cammatrix+6*4
    call    MATH_VecSub
    call    MATH_Normalize


    sub     edi, 6*4                ; lea     edi, cammatrix

    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    fldz                            ; 0
    fstp    dword [edi+4]       ;
    ;
    fld     dword [edi+32]      ; z
    fst     dword [edi+0]       ; z
    ;
    fld     dword [edi+24]      ; z  x
    fchs                            ; z -x
    fst     dword [edi+8]       ; z -x
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    fmul    dword [edi+28]      ; z -xy
    fstp    dword [edi+12]      ; z
    ;
    fld     dword [edi+28]      ; z   y
    fmul    st1, st0            ; zy  y
    fmul    st0, st0            ; zy  y²
    fld1                            ; zy  y² 1
    fsubrp  st1                     ; zy  1-y²
    fstp    dword [edi+16]      ; zy
    ;
    fchs                            ; -zy
    fstp    dword [edi+20]      ;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


    ; esc[0] = -x + y + z
    ; esc[1] =  x + y + z
    ; esc[2] = -x - y + z

    mov     ebp, edi            ; lea     ebx, cammatrix
    mov     esi, cammatrix+6*4
    mov     edi, esc0
    call    MATH_VecSub             
    sub     esi, 3*4            ; lea     esi, cammatrix+3*4
    call    MATH_VecAdd2        ; esc[0] = -x + y + z


%if 0
    mov     edi, ebp            ; lea     edi, cammatrix+0
    fld     dword ptr [s ddx]
    call    MATH_VecScale       ; incx = (esc1 - esc0) / (XRES-1)

    ;add     edi, 12             ; lea     edi, cammatrix+12
    mov     edi, esi
    fld     dword ptr [s ddy]
    call    MATH_VecScale       ; incy = (esc1 - esc0) / (XRES-1)
%else
    mov     edx, ddx
    mov     edi, ebp            ; lea     edi, cammatrix+0
    fld     dword [edx]
    call    MATH_VecScale       ; incx = (esc1 - esc0) / (XRES-1)

    ;add     edi, 12             ; lea     edi, cammatrix+12
    mov     edi, esi
    fld     dword [edx+4]
    call    MATH_VecScale       ; incy = (esc1 - esc0) / (XRES-1)

%endif


    popad
    ret
