%include "main.inc"
%include "mlib.inc"
%include "mmath.inc"
%include "ray_dofr.inc"
%include "ray_bola.inc"

[GLOBAL echa_rayo]
[GLOBAL rptr]
[GLOBAL luz]
[GLOBAL camtarget]
[GLOBAL campos]
[GLOBAL normal]
[GLOBAL zbuf]
[GLOBAL aux0]
%if ATENUA==1
[GLOBAL aten]
%endif

AMBI     equ 85
NOOBJ    equ  1   ; 1 :: -15 bytes!
LUZCLAMP equ  1   ; 0 ::  -8 bytes!
AUTOSOM  equ  0   ; 1 ::  -7 bytes!

[SEGMENT .data USE32]



%if ATENUA==1
aten        dd  0.00001
%endif
luz         dd  30.0, 40.0, -30.0
camtarget   dd  0, -25.0, 0
R255        dd  170.0       ; deform

[SEGMENT .bss USE32]

rptr    RESD   1
campos  RESD   3
zbuf    RESD   1
ilu     RESD   1
aux0    RESD   1 
inter   RESD   3
normal  RESD   3
v       RESD   3

EXTERN  text0   ; iqiqiq
EXTERN  text1
EXTERN  text2


[SEGMENT .text USE32]

echa_rayo:
    pushad

    mov     dword [zbuf], 0501502f9h      ; 10^10


    %if NOOBJ==0
    xor eax, eax
    %endif

    ;----------------
    %if NOOBJ==0
    xor     ebx, ebx                ; optr
    %endif
    mov     esi, dir
    mov     edi, campos
    mov     ebp, [rptr]
    movzx   ecx, byte [ebp]
    inc     ebp
    @loopint:
        call    CUADRIC_Interseca
        jnc     no
            mov     ebx, ebp
            fstp    dword [zbuf]    ;
        no:
        add     ebp, byte CUADRIC_SIZE
    loop @loopint

    %if NOOBJ==0
    or      ebx, ebx
    jz      @no
    %endif



    ;--------------------- iluminación ---------------------------------
    ; calculamos punto de intersección
    ; inter = campos + dir·t

    mov     edi, esi    ; edi = dir
    fld     dword [zbuf]
    call    MATH_VecScale
    mov     esi, campos
    call    MATH_VecAdd2

    ; calculamos la normal y las coords de textura 

    call    CUADRIC_NormalAndText      ; ecx=0
    movzx   edx, word [aux0]     ; edx=off


    ; calculamos v = luz-inter
    mov     esi, luz
    mov     ebp, dir    ; inter
    mov     edi, v
    call    MATH_VecSub
    call    MATH_Modulo             ; mod
    fst     dword [zbuf]            ; mod
    fld1                            ; mod 1
    fdivrp  st1                     ; imod
    call    MATH_VecScale           ;

    mov     dword [ilu], AMBI


    ; angulo entre normal y v

    mov     esi, normal
    ;mov     edi, v              
    call    MATH_VecDot             ; ang


    ; if( ang<0 ) goto @no_luz;
    %if P6==1
    fldz                                          ; a b' b'²-ac 0.0
    fcomip   st0, st1                             ; a b' b'²-ac
    ;ftsti
    ja      @no_luz
    %else
    ftst                            ; ang
    fnstsw  ax
    sahf
    jb      @no_luz
    %endif

            mov     esi, edi    ; v
            mov     edi, dir    ; inter
            mov     ebp, [rptr]
            ;movzx   ecx, byte [ebp]
            mov     cl, [ebp]
            inc     ebp
            @loopint2:
                %if AUTOSOM==0
                cmp     ebx, ebp
                je      nosom
                %endif
                call    CUADRIC_Interseca
                jc      @no_luz2
                nosom:
                add     ebp, byte CUADRIC_SIZE
            loop @loopint2

        fmul    dword [R255]        ; ang·255

        %if ATENUA==1
            fld     dword [zbuf]  ; ang·255 mod
            fmul    st0, st0        ; ang·255 mod²
            fmul    dword [aten]  ; ang·255 mod²·aten
            fld1                        ; ang·255 mod²·aten 1       ; ■ podríamos quitar estas 2 líneas si sabemos
            faddp   st1                 ; ang·255 1+mod²·aten       ; q la luz no estára más cerca de 1m de cualquier objeto
            fdivp   st1                 ; ang·255/(1+mod²·aten)
        %endif


    mov     esi, ilu
    fiadd   dword [esi]             ; ilu = ambiente + ang...
    fist    dword [esi]             ; ilu

    @no_luz2:
    fstp    st0

    @no_luz:
    fstp  st0                           ;

    ; ebx = optr
    ; edx = offset
    ;-- text
    movzx   ecx, byte [ebx+28]  ; text
    shl     ecx, 18
    %if 0
    mov     esi, text0
    add     esi, ecx
    mov     eax, [esi+4*edx]            ; edx=off
    %else
    mov     eax, [text0+4*edx+ecx]            ; edx=off
    %endif

    mov     ecx, [ilu]
    %if LUZCLAMP==1
    or      ch, ch
    jnz     @siclamp
    %endif
    call    RGB_Scale                   ; machaca edx
    @siclamp:


    ;--------------------- iluminación ---------------------------------

    @no:

    mov [esp+28], eax
    popad

    ret
