;----------------------------------------------------------------------------;
;                                                                            ;
;                      Mini Generador de Texturas                            ;
;                       para intros de 4k (PMode)                            ;
;                                                                            ;
;                              by iq/glue                                    ;
;                                                                            ;
;----------------------------------------------------------------------------;
%include "main.inc"
%include "mlib.inc"
%include "plas.inc"
EXTERN dumpbuf



[GLOBAL TG_Inpure]
[GLOBAL TG_PlasRGB]
[GLOBAL TG_Parabola]

[SEGMENT .text USE32]

; edi
TG_Inpure:
    pushad

    mov     ebp, 256*256
    @loopIm:

        movzx       ecx, byte [edi+0]   ; ecx = b
        movzx       ebx, byte [edi+1]   ; ecx = g
        movzx       edx, byte [edi+2]   ; ecx = r

        mov         eax, edx
        add         eax, ebx
        add         eax, ecx                ; eax = r+g+b

        %if P6==1
            cmp         ecx, ebx
            db          00Fh, 04ch, 0cbh    ;cmovl       ecx, ebx
            cmp         ecx, edx
            db          00Fh, 04ch, 0cah    ;cmovl       ecx, edx
        %else
            cmp         ecx, ebx
            jg          @no1
            mov         ecx, ebx
            @no1:
            cmp         ecx, edx
            jg          @no2
            mov         ecx, edx
            @no2:
        %endif

                                            ; ecx = max
        lea         ecx, [ecx+ecx*2]        ; ecx = 3*max
        inc         ecx                     ; para evitar divir entre 0

        shl         eax, 8                  ; eax = (r+g+b)<<8
        cdq
        idiv        ecx                     ; eax = ((r+g+b)<<8)/(3*max)

        xchg        eax, ecx                ; mov ecx, eax
        mov         eax, [edi]
        call        RGB_Scale
        stosd

    dec    ebp
    jnz    @loopIm

    popad
    ret



;----------------------------------------------------------------------------;
; TG_Soften
;
; in      :  edi
; out     :
; machaca :
;
;----------------------------------------------------------------------------;
%if 0
TG_Soften:
    pushad

    xor edx, edx
    @loopSOF:
    
        mov     ebx, edx
    
        inc     bl
        mov     eax, [edi+4*ebx]
        sub     bl, 2
        mov     ecx, [edi+4*ebx]
        call    RGB_Blend
        push    eax

        inc     bl
        inc     bh
        mov     ecx, [edi+4*ebx]
        sub     bh, 2
        mov     eax, [edi+4*ebx]
        call    RGB_Blend

        pop     ecx
        call    RGB_Blend

        mov     [edi+4*edx], eax
    
    inc dx
    jno @loopSOF

    popad
    ret
%endif




;
; edi : destino
; aux
TG_PlasRGB:
    pushad

    mov     ebp, edi
    xor     edx, edx
    @loopPlasCol:
        mov     edi, ebp
        mov     esi, dumpbuf
        call    PLASMA_Hace256
        add     edi, edx
        mov     ecx, 256*256
        @loopPlas:
            movsb
            add     edi, byte 3
        loop @loopPlas
        inc edx
        cmp dl, 3
    jl @loopPlasCol

    popad
    ret


;
; x = 4*x*(1-x)
;
; x = ((255-x)*x)/64
;
; edi : tex
;
TG_Parabola:
    pushad

    mov     ecx, (256*256*4)
    @loopPara:
        movzx   ebx, byte [edi]
        xor     eax, eax
        dec     al
        sub     eax, ebx
        imul    eax, ebx
        shr     eax, 6
        stosb
    loop    @loopPara

    popad
    ret
